seo:
  title: Code Suggestions available to all GitLab tiers while in Beta
  description: >-
    All users can acess Code Suggestions AI-assisted feature while it is in
    Beta.
  ogTitle: Code Suggestions available to all GitLab tiers while in Beta
  ogDescription: >-
    All users can acess Code Suggestions AI-assisted feature while it is in
    Beta.
  noIndex: false
  ogImage: images/blog/hero-images/ai-experiment-stars.png
  ogUrl: https://about.gitlab.com/blog/code-suggestions-for-all-during-beta
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/code-suggestions-for-all-during-beta
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "Code Suggestions available to all GitLab tiers while in Beta",
            "author": [{"@type":"Person","name":"Neha Khalwadekar"}],
            "datePublished": "2023-05-16",
          }

content:
  title: Code Suggestions available to all GitLab tiers while in Beta
  description: >-
    All users can acess Code Suggestions AI-assisted feature while it is in
    Beta.
  authors:
    - Neha Khalwadekar
  heroImage: images/blog/hero-images/ai-experiment-stars.png
  date: '2023-05-16'
  body: >


    <i>This blog is the latest post in an ongoing series about GitLab’s journey
    to <a href="/blog/2023/04/24/ai-ml-in-devsecops-series/">build and integrate
    AI/ML into our DevSecOps platform</a>. The first blog post can be found <a
    href="/blog/2023/03/16/what-the-ml-ai/">here</a>. Throughout the series,
    we’ll feature blogs from our product, engineering, and UX teams to showcase
    how we’re infusing AI/ML into GitLab.</i>


    Code Suggestions is now available on GitLab.com for all users for free while
    the feature is in Beta. Teams can boost efficiency with the help of
    generative AI that suggests code while you're developing. We've extended
    language support from our initial six languages to now include 13 languages:
    C/C++, C#, Go, Java, JavaScript, Python, PHP, Ruby, Rust, Scala, Kotlin, and
    TypeScript. 


    We are making improvements to the Code Suggestions underlying AI model
    weekly to improve the quality of suggestions. Please remember that AI is
    non-deterministic, so you may not get the same suggestion week to week.


    ## Privacy first

    Code Suggestions is built with privacy as a critical foundation. It keeps
    your proprietary source code secure within GitLab's enterprise cloud
    infrastructure, and this code isn't used as training data. Source code
    inference against the Code Suggestions model is not used to re-train the
    model. Learn about [data usage when using Code
    Suggestions](https://docs.gitlab.com/ee/user/project/repository/code_suggestions.html#code-suggestions-data-usage). 


    ## IDE support

    Code Suggestions is available in VS Code via the [GitLab Workflow
    extension](https://docs.gitlab.com/ee/user/project/repository/vscode.html#gitlab-workflow-extension-for-vs-code).
    We will soon support the GitLab WebIDE with GitLab 16.0. We are also working
    on adding [additional IDE
    support](https://gitlab.com/groups/gitlab-org/-/epics/10542) based on
    customer feedback, including JetBrains IntelliJ-based IDEs and Visual Studio
    support for code suggestions. We are also working to improve the user
    experience for how suggestions are presented and accepted within the IDEs to
    give developers more control over how the feature works. Additionally we're
    working to make it easier to setup Code Suggestions the first time and
    authenticate with GitLab.com 


    ## Self-managed support

    We are also working to bring Code Suggestions to self-managed instances [via
    a secure connection to
    GitLab.com](https://gitlab.com/groups/gitlab-org/-/epics/10528). If you have
    unique requirements for your self-managed instances, we welcome you to
    express your interest in our [self-managed support
    issue](https://gitlab.com/gitlab-org/gitlab/-/issues/409183). Commenting on
    that issue will give you notifications as we post updates. 


    ## Enable Code Suggestions

    Our documentation details how to [enable Code Suggestions in VS
    Code](https://docs.gitlab.com/ee/user/project/repository/code_suggestions.html#enable-code-suggestions-in-vs-code).
    Below is a quickstart video walkthrough:


    <!-- blank line -->

    <figure class="video_container">

    <iframe width="560" height="315"
    src="https://www.youtube.com/embed/WnxBYxN2-p4" title="YouTube video player"
    frameborder="0" allow="accelerometer; autoplay; clipboard-write;
    encrypted-media; gyroscope; picture-in-picture; web-share"
    allowfullscreen></iframe>

    </figure>

    <!-- blank line -->


    ## Beta feature

    This feature is in
    [Beta](https://docs.gitlab.com/ee/policy/experiment-beta-support.html#beta).
    Code Suggestions uses generative AI to suggest code while you're developing.
    Due to high demand, this feature will have unscheduled downtime and code
    suggestions in VS Code may be delayed. Code Suggestions may produce
    [low-quality or incomplete
    suggestions](https://docs.gitlab.com/ee/user/project/repository/code_suggestions.html#model-accuracy-and-quality).
    We look forward to hearing your feedback. Beta users should read about the
    [known
    limitations](https://docs.gitlab.com/ee/user/project/repository/code_suggestions.html#known-limitations). 


    We would love to hear about your experience and report issues in the
    [feedback issues](https://gitlab.com/gitlab-org/gitlab/-/issues/405152). 


    Code Suggestions is just one of the ways we’re infusing GitLab with AI/ML
    capabilities to help GitLab users become more efficient and effective at
    their jobs. We are [looking across the software development
    lifecycle](/blog/2023/03/16/what-the-ml-ai/) for painful and time-consuming
    tasks that are ideal for AI-assisted features. We'll continue to share these
    demos throughout this blog series.


    Interested in using these AI-powered features? [Join our
    waitlist](https://forms.gle/9eeUkPJauKsbLaoz5) and share your ideas.


    Continue reading our "[AI/ML in
    DevSecOps](https://about.gitlab.com/blog/2023/04/24/ai-ml-in-devsecops-series/)"
    series.


    _Disclaimer: This blog contains information about upcoming products,
    features, and functionality. It is important to note that the information in
    this blog post is for informational purposes only. Please do not rely on
    this information for purchasing or planning purposes. As with all projects,
    the items mentioned in this blog and linked pages are subject to change or
    delay. The development, release, and timing of any products, features, or
    functionality remain at the sole discretion of GitLab._
  category: AI/ML
  tags:
    - DevSecOps
    - product
    - features
    - AI/ML
config:
  slug: code-suggestions-for-all-during-beta
  featured: false
  template: BlogPost
